package com.example.zego_zpns.internal;

import android.content.Context;
import android.os.Handler;
import android.os.Looper;


import com.vivo.push.model.UPSNotificationMessage;
import com.xiaomi.mipush.sdk.MiPushMessage;
import com.huawei.hms.push.RemoteMessage;
import com.heytap.msp.push.mode.DataMessage;
import java.util.HashMap;

import im.zego.zpns.ZPNsMessageReceiver;

import im.zego.zpns.entity.ZPNsMessage;
import im.zego.zpns.entity.ZPNsRegisterMessage;


import im.zego.zpns.internal.receiver.FCMMessageService;

import io.flutter.plugin.common.EventChannel;

public class ZPNsPluginEventHandler extends ZPNsMessageReceiver{
    
    public static EventChannel.EventSink mysink = null;

    public void setSink(EventChannel.EventSink sink){
        mysink = sink;
    }

    @Override
    protected void onThroughMessage(Context context, ZPNsMessage message) {
        //dart 暂未封装该接口,有需要再封装

//        if(mysink == null){
//            return;
//        }
//        HashMap<String,Object> resultMap = new HashMap<>();
//        resultMap.put("method","onThroughMessage");
//        resultMap.put()
//        resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));
//        Handler handler = new Handler(Looper.getMainLooper());
//        handler.post(new Runnable() {
//            @Override
//            public void run() {
//                mysink.success(resultMap);
//            }
//        });
    }

    @Override
    protected void onNotificationClicked(Context context, ZPNsMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();
        HashMap<String,String> messageMap = new HashMap<>();
        messageMap.put("title",message.getTitle());
        messageMap.put("content",message.getContent());
        messageMap.put("extendedData",ZPNsConverter.getZPNsMessageExtendedData(message));
        resultMap.put("method","onNotificationClicked");
        resultMap.put("message",messageMap);

        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(new Runnable() {
            @Override
            public void run() {
                mysink.success(resultMap);
            }
        });
    }

    @Override
    protected void onNotificationArrived(Context context, ZPNsMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        HashMap<String,String> messageMap = new HashMap<>();
        messageMap.put("title",message.getTitle());
        messageMap.put("content",message.getContent());
        messageMap.put("extendedData",ZPNsConverter.getZPNsMessageExtendedData(message));

        resultMap.put("method","onNotificationArrived");
        resultMap.put("message",messageMap);

        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(new Runnable() {
            @Override
            public void run() {
                mysink.success(resultMap);
            }
        });
    }

    @Override
    protected void onRegistered(Context context, ZPNsRegisterMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        resultMap.put("method","onRegistered");

        HashMap<String,Object> messageMap = new HashMap<>();
        messageMap.put("pushID",message.getCommandResult());
        messageMap.put("errorCode",message.getErrorCode().getCode());

        resultMap.put("message",messageMap);


        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(new Runnable() {
            @Override
            public void run() {
                mysink.success(resultMap);
            }
        });

    }
}
